"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var CannerRefId = function CannerRefId(initString) {
  var _this = this;

  (0, _classCallCheck2.default)(this, CannerRefId);
  (0, _defineProperty2.default)(this, "_internalArr", void 0);
  (0, _defineProperty2.default)(this, "getPathArr", function () {
    return _this._internalArr;
  });
  (0, _defineProperty2.default)(this, "toString", function () {
    return _this._internalArr.join("/");
  });
  (0, _defineProperty2.default)(this, "child", function (route) {
    var newRoute = _this._internalArr && _this._internalArr.length ? _this._internalArr.join("/").concat("/", route) : route;
    return new CannerRefId(newRoute);
  });
  (0, _defineProperty2.default)(this, "remove", function () {
    var count = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;

    var newRoute = _this._internalArr.slice(0, -count).join("/");

    return new CannerRefId(newRoute);
  });
  this._internalArr = initString ? initString.split('/') : [];
};

exports.default = CannerRefId;